package com.ruoyi.platform.service;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.ruoyi.platform.domain.Dataset;
import com.ruoyi.platform.domain.Workflow;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

/**
 * DAG workflow(Workflow)表服务接口
 *
 * @author makejava
 * @since 2023-10-18 14:17:10
 */
public interface WorkflowService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    Workflow queryById(Long id);

    /**
     * 分页查询
     *
     * @param workflow    筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    Page<Workflow> queryByPage(Workflow workflow, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param workflow 实例对象
     * @return 实例对象
     */
    Workflow insert(Workflow workflow) throws Exception;

    /**
     * 修改数据
     *
     * @param workflow 实例对象
     * @return 实例对象
     */
    Workflow update(Workflow workflow) throws Exception;

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    String removeById(Long id) throws Exception;
    /**
     * 按流水线名字模糊分页查询
     *
     * @param name    筛选条件
     * @return 查询结果
     */
    Page<Workflow> queryByName(String name);

    Workflow duplicateWorkflow(Long id);

    void checkDeclaredName(Workflow insert) throws Exception;

    /**
     * 按流水线id保存
     *
     * @param id  主键
     * @return 查询结果
     */
//    Workflow saveWorkflow(Long id);
}
